
#define FILTERSCRIPT

#include <a_samp>
#include <sscanf2>

const IPLC_MODE = 0; // 0 = CreateObject to IPL, 1 = IPL to CreateObject

public OnFilterScriptInit()
{
	switch(IPLC_MODE)
	{
		case 0:
		{
			new File:infile = fopen("iplc/input.txt", io_read);
			new File:outfile = fopen("iplc/output.txt", io_write);
			
			print(" IPLC - IPLConventer by JoKeR_2020");
			
			fwrite(outfile, "# IPLC - IPLConventer by JoKeR_2020\r\n");
			fwrite(outfile, "inst\r\n");
			
			new buffer[128];
			
			while(fread(infile, buffer))
			{
				strdel(buffer, 0, 13);
				
				new pos = strfind(buffer, ");");
				if(pos != -1)
				{
					buffer[pos] = '\0';
				}
				
				new modelid = 0;
				new Float:x = 0.0;
				new Float:y = 0.0;
				new Float:z = 0.0;
				new Float:rx = 0.0;
				new Float:ry = 0.0;
				new Float:rz = 0.0;
				
				sscanf(buffer, "p<,>iffffff", modelid, x, y, z, rx, ry, rz);
				
				printf("> %i %f %f %f %f %f %f", modelid, x, y, z, rx, ry, rz);
				
				new Float:qw = 0.0;
				new Float:qx = 0.0;
				new Float:qy = 0.0;
				new Float:qz = 0.0;
				
				GetRotationQuaternion(rx, ry, rz, qw, qx, qy, qz);
				
				format(buffer, sizeof(buffer), "%i, dummy, 0, %f, %f, %f, %f, %f, %f, %f, -1\r\n", modelid, x, y, z, qx, qy, qz, qw);
				
				fwrite(outfile, buffer);
			}
			
			fwrite(outfile, "end\r\n");
			
			fclose(outfile);
			fclose(infile);
		}
	}
	return 1;
}

/*
	http://pastebin.com/SunmLUZg
*/

stock GetQuaternionAngles(Float:w, Float:x, Float:y, Float:z, &Float:xa, &Float:ya, &Float:za)
{
    xa = asin(2*y*z - 2*x*w);
    ya = -atan2(x*z + y*w, 0.5 - x*x - y*y);
    za = -atan2(x*y + z*w, 0.5 - x*x - z*z);
}

stock GetRotationQuaternion(Float:x, Float:y, Float:z, &Float:qw, &Float:qx, &Float:qy, &Float:qz)
{
    new Float:cx = floatcos(-0.5*x, degrees);
    new Float:sx = floatsin(-0.5*x, degrees);
    new Float:cy = floatcos(-0.5*y, degrees);
    new Float:sy = floatsin(-0.5*y, degrees);
    new Float:cz = floatcos(-0.5*z, degrees);
    new Float:sz = floatsin(-0.5*z, degrees);
    qw = cx * cy * cz + sx * sy * sz;
    qx = cx * sy * sz + sx * cy * cz;
    qy = cx * sy * cz - sx * cy * sz;
    qz = cx * cy * sz - sx * sy * cz;
}